import { CategorySeries } from "./CategorySeries";
import { IIsCategoryBased } from "./IIsCategoryBased";
import { IHasSingleValueCategory } from "./IHasSingleValueCategory";
import { IHasCategoryTrendline } from "./IHasCategoryTrendline";
import { ITrendLineSeries } from "./ITrendLineSeries";
import { IAnchoredCategorySeriesInteractionManager } from "./IAnchoredCategorySeriesInteractionManager";
import { Type, Point } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
import { IFastItemColumn$1 } from "igniteui-angular-core";
import { TrendLineType } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { PenLineCap } from "igniteui-angular-core";
import { DoubleCollection } from "igniteui-angular-core";
import { CategoryFrame } from "./CategoryFrame";
import { CategoryMode } from "./CategoryMode";
import { ICategoryScaler } from "./ICategoryScaler";
import { IScaler } from "./IScaler";
import { IBucketizer } from "./IBucketizer";
import { CategorySeriesView } from "./CategorySeriesView";
import { IPreparesCategoryTrendline } from "./IPreparesCategoryTrendline";
import { CategorySeriesMarkerCollisionAvoidance } from "./CategorySeriesMarkerCollisionAvoidance";
import { ConsolidatedItemHitTestBehavior } from "./ConsolidatedItemHitTestBehavior";
import { SeriesView } from "./SeriesView";
import { List$1 } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { Axis } from "./Axis";
import { ITrendLineManager } from "./ITrendLineManager";
import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
import { AxisRange } from "./AxisRange";
import { FastItemsSourceEventAction } from "igniteui-angular-core";
import { PointCollection } from "igniteui-angular-core";
import { Clipper } from "igniteui-angular-core";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { RenderSurface } from "./RenderSurface";
import { IDetectsCollisions } from "./IDetectsCollisions";
import { ValueLayerValueMode } from "./ValueLayerValueMode";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare abstract class AnchoredCategorySeries extends CategorySeries implements IIsCategoryBased, IHasSingleValueCategory, IHasCategoryTrendline, ITrendLineSeries {
    static $t: Type;
    private aai;
    get aaj(): IAnchoredCategorySeriesInteractionManager;
    aae: AnchoredCategorySeriesView;
    getHostReferenceValue(): number;
    mc(): string;
    protected cq(): SeriesView;
    qx(a: SeriesView): void;
    aan: boolean;
    constructor();
    aa4: string;
    ko(a: any, b: string): any;
    mb(a: string): string;
    get valueColumn(): IFastItemColumn$1<number>;
    set valueColumn(a: IFastItemColumn$1<number>);
    private aak;
    aaw: string;
    aa0: string;
    aa2: string;
    getDataLegendSeriesContextAt(a: number, b: number): any;
    trendLineType: TrendLineType;
    trendLineBrush: Brush;
    get abr(): Brush;
    set abr(a: Brush);
    static readonly abd: DependencyProperty;
    trendLineThickness: number;
    abt: PenLineCap;
    abs: DoubleCollection;
    trendLinePeriod: number;
    aar: number;
    gb(a: any): boolean;
    protected aab(a: number, b: number, c: Axis): any[];
    protected q5(a: any, b: string, c: any, d: any): void;
    ax(a: Axis): AxisRange;
    protected o9(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    protected zl(): number;
    aaq(a: CategorySeriesView): number;
    aba(a: PointCollection, b: number, c: CategorySeriesView): void;
    aac(a: List$1<number[]>, b: number, c: Rect, d: Rect): Clipper;
    aad(a: List$1<number[]>, b: number, c: Rect, d: Rect, e: boolean): Clipper;
    protected f9(): boolean;
    protected hr(): List$1<SeriesLayerPropertyOverlay>;
    private aa6;
    hc(a: Rect, b: Rect, c: SeriesView): boolean;
    o3(a: boolean, b: SeriesView): void;
    z1(a: CategoryFrame, b: CategorySeriesView): void;
    z4(a: CategoryFrame, b: CategorySeriesView): void;
    aaf: CategoryFrame;
    rm(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    aa7(a: CategoryFrame, b: CategorySeriesView): void;
    protected sb(): void;
    kv(a: any, b: Point): any;
    get currentCategoryMode(): CategoryMode;
    get scaler(): ICategoryScaler;
    get yScaler(): IScaler;
    get bucketizer(): IBucketizer;
    get currentMode2Index(): number;
    provideCollisionDetector(): IDetectsCollisions;
    get trendlinePreparer(): IPreparesCategoryTrendline;
    protected aau: string;
    protected aat: string;
    abstract aa8(a: Axis): void;
    abstract aa9(a: Axis): void;
    protected pv(a: any): void;
    aag: CategorySeriesMarkerCollisionAvoidance;
    kl(a: Point): any;
    aah: ConsolidatedItemHitTestBehavior;
    get mayContainUnknowns(): boolean;
    iw(): number;
    protected get_aas(): number;
    protected get aas(): number;
    ay(a: Rect): AxisRange;
    private abc;
    private aam;
    private aao;
    aap: number;
    private abb;
    i6(a: ValueLayerValueMode, b: Axis): number;
    ap(a: ValueLayerValueMode): number[];
    v9(a: ValueLayerValueMode): Point;
    wa(a: number[]): Point;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class AnchoredCategoryBucketCalculator extends CategoryBucketCalculator {
    static $t: Type;
    constructor(a: AnchoredCategorySeriesView);
    protected i: AnchoredCategorySeriesView;
    getBucketWithoutUnknowns(a: number): number[];
    getBucket(a: number): number[];
    private h;
    private j;
    cacheValues(): void;
    unCacheValues(): void;
}
/**
 * @hidden
 */
export declare class AnchoredCategorySeriesView extends CategorySeriesView {
    static $t: Type;
    c5: AnchoredCategorySeries;
    constructor(a: AnchoredCategorySeries);
    private c6;
    get c7(): ITrendLineManager;
    set c7(a: ITrendLineManager);
    get c8(): boolean;
    dc(): void;
    da(): void;
    c9(): void;
    cx(): CategoryBucketCalculator;
    db(): void;
    dd(): void;
    de(a: number): Rect;
    protected a7(a: RenderingContext, b: boolean): void;
    getDefaultTooltipTemplate(): string;
}
